#!/usr/bin/env python
#    This file is part of caseB.
#
#    caseB is free software: you can redistribute it and/or modify it
#    under the terms of the GNU General Public License as published by
#    the Free Software Foundation, either version 3 of the License, or
#    (at your option) any later version.
#
#    caseB is distributed in the hope that it will be useful, but
#    WITHOUT ANY WARRANTY; without even the implied warranty of
#    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
#    General Public License for more details.
#
#    You should have received a copy of the GNU General Public License
#    along with caseB.  If not, see <http://www.gnu.org/licenses/>.

# Copyright (c) Naoki ONISHI.
# All rights reserved.

import commands
boxFile = open('box.dat','r')
boxFile.seek(0)
cellSetFile = open('system/cellSetDict.boxes','w')
cellSetFile.write("FoamFile\n{ \n\
    version \t 2.0;\n\
    format \t ascii;\n\n\
    root \t \".\";\n\
    case \t \".\";\n\
    instance \t \"system\";\n\
    local \t \"\";\n\n\
    class \t dictionary;\n\
    object \t cellSetDict;\n\
}\n\n\
name boxes;\n\
action new;\n\
topoSetSources\n\
(\n\
")
line = 0
for line in boxFile:
   (sx,sy,sz,ex,ey,ez)=(0,0,0,0,0,0)
   points = line[:-1].split(' ')
   if len(points) > 1:
#      (sx,sy,sz,ex,ey,ez)=(float(points[0]),float(points[1]),float(points[2]),\
      (sx,sy,sz,ex,ey,ez)=(points[0],points[1],points[2],\
                           points[3],points[4],points[5])
#      cellSetFile.write("boxToCell\n\t{\n\t\
#      box ("+repr(sx)+" "+repr(sy)+" "+repr(sz)+") ("+repr(ex)+" "+repr(ey)+" "+repr(ez)+");\n\t}\n")
      cellSetFile.write("boxToCell\n\t{\n\t\
      box ("+sx+" "+sy+" "+sz+") ("+ex+" "+ey+" "+ez+");\n\t}\n")

cellSetFile.write(");")
invertFile = open('system/cellSetDict.invert','w')
invertFile.write("FoamFile\n{ \n\
    version \t 2.0;\n\
    format \t ascii;\n\n\
    root \t \".\";\n\
    case \t \".\";\n\
    instance \t \"system\";\n\
    local \t \"\";\n\n\
    class \t dictionary;\n\
    object \t cellSetDict;\n\
}\n\n\
name boxes;\n\
action invert;\n\
topoSetSources\n\
(\n);\n\
")

cellSetFile.close()
invertFile.close()

commands.getstatusoutput('cp -rf system/cellSetDict.boxes system/cellSetDict')
commands.getstatusoutput('cellSet >> log.cellSet 2>&1 ')
commands.getstatusoutput('cp -rf system/cellSetDict.invert system/cellSetDict')
commands.getstatusoutput('cellSet >> log.cellSet 2>&1 ')
commands.getstatusoutput('subsetMesh boxes >> log.cellSet 2>&1 ')

print "end"
